# BCTReader

Beam Current Transformer, retrieves beam intensity and correlates it with a
timing event.

## Build

To build this project it is recommended to install [x-builder](https://gitlab.cern.ch/ntof/daq/common/tools/x-builder) script.

```bash
x-builder

rm -rf build && mkdir build
cd build && cmake3 .. -DTESTS=ON

make -j4
```

## Testing

To run unit-tests:
```bash
x-builder ./build/tests/test_all
```

To run linters:
```bash
x-builder make -C build lint
```

## Running

To run this service on a local DIM/DNS node, edit `tests/data/misc.xml` to set the DIM/DNS address.

Then to connect the service from a container to this DNS:
```bash
x-builder
export DIM_HOST_NODE=$(hostname -i)
./build/src/BCTReader -c ./tests/data/bctreader.xml -m ./tests/data/misc.xml

# Alternatively, one can also expose service directly on current host:
OPTS='--network=host --userns=host' x-builder
./build/src/BCTReader -c ./tests/data/bctreader.xml -m ./tests/data/misc.xml
```

## Debugging

To compile this component for gdb/lldb:
```bash
x-builder

cd build && cmake3 -DCMAKE_BUILD_TYPE=Debug ..
```
